#include <bits/stdc++.h>
using namespace std;
int N,kol[10005],primioA[10005],primioO[10005],primioB[1005],primioAB[10005],kA,kO,kB,kAB,sum;
string g;
int main() {
    cin >> N;
    cin >> kO >> kA >> kB >> kAB;
    for (int i=1;i<=N;i++) {
        cin >> g >> kol[i];
        for (int t=1;t<=N;t++){
            sum=kol[i];
        }

        if (sum>kA+kB+kO+kAB){
            cout << "nemoguce" << endl;
        }
        else{
            if (g=="A"){
                while (kol[i]>0 and kA>0){
                    primioA[i]++;
                    kol[i]--;
                    kA--;
                }
                if (kol[i]>0 and kA==0){
                    while (kol[i]>0 and kO>0){
                        primioO[i]++;
                        kol[i]--;
                        kO--;
                    }
                }
            }

            if (g=="B"){
                while (kol[i]>0 and kB>0){
                    primioB[i]++;
                    kol[i]--;
                    kB--;
                }
                if (kol[i]>0 and kB==0){
                    while (kol[i]>0 and kO>0){
                        primioO[i]++;
                        kol[i]--;
                        kO--;
                    }
                }
            }

            if (g=="O"){
                while (kol[i]>0 and kO>0){
                    primioO[i]++;
                    kol[i]--;
                    kO--;
                }
            }
        }
    }
    return 0;
}